;v1.6 myndzi 11/08/2007
;iinc.mrc@masquerader.com

on *:load:{
  .disable #iinc_oc
  .timerreoc 1 0 .enable #iinc_oc
  if ($isalias(oc_chk)) {
    var %i = $script(0), %j, %t = ;1.3, %v = $true
    while (%i) { 
      if ($read($script(%i), nw, alias oc_chk *)) {
        %j = $readn + 1
        if ($read($script(%i), n, %j) != %t) {
          if (%v) {
            echo -a *** Conflict alert ***
            echo -a The following files have old copies of my oc_chk aliases:
            %v = $false
          }
          dec %j
          echo -a Line $base(%j, 10, 10, 5) in $script(%i)
        }
      }
      dec %i
    }
    if (!%v) {
      echo -a These will need to be updated or loaded below iinc.mrc in order for iinc to be fully functional.
      echo -a You may type /iinc_patch to automatically fix these files.
    }
  }
  .timerreoc -e
  if ($version < 6) .enable #iinc.591
  else .disable #iinc.591
  scid -at1 iinc_names
}
on *:unload:if ($hget(iinc)) hfree iinc | hfree -w iinc.? | scid -a window -c @iinc. $!+ $!cid | .timer 1 0 if ($isalias(oc_chk) == $!false) hfree oc

on *:connect:window -lhn $iinc.win
on *:disconnect:if ($window($iinc.win)) { window -c $ifmatch | if ($hget($ifmatch)) hfree $ifmatch }

on *:close:@iinc.*:.timer 1 0 scid $gettok($target,2,46) iinc_names

;keep nicks list accurate
on me:*:join:#:hadd -m $iinc.win $chan $true
on me:*:part:#:filter -cxww $iinc.win $iinc.win $chan *
on me:*:quit:if ($window($iinc.win)) { window -c $ifmatch | if ($hget($ifmatch)) hfree $ifmatch }

on !*:join:*:aline $iinc.win $chan * $nick $nickstrip($nick)
on *:nick:var %i = $fline($iinc.win,& & $nick &,0), %t | while (%i) { %t = $fline($iinc.win,& & $nick &,%i) | rline $iinc.win %t $gettok($line($iinc.win,%t),1,32) * $newnick $nickstrip($newnick) | dec %i }
on !*:part:*:dline $iinc.win $fline($iinc.win,$chan & $nick &,1)
on !*:quit:filter -cxww $iinc.win $iinc.win & & $nick &

on *:kick:*:if ($knick != $me) dline $iinc.win $fline($iinc.win,$chan & $knick &,1) | else filter -cxww $iinc.win $iinc.win $chan *

raw 353:*:{
  if (!$hget($iinc.win, $3)) return
  var %re = /(?<=\s)[ $+ $prefix $+ ]*(\S*)/g
  var %t = $regsubex($4-, %re, \t), %u
  var %i = $numtok(%t,32)
  while (%i) {
    ;if ($gettok($gettok(%t, %i, 32), 1, 33) != $me)
    %u = $gettok($gettok(%t, %i, 32), 1, 33)
    aline $iinc.win $3 * %u $nickstrip(%u)
    dec %i
  }
}
raw 366:*:if (!$hget($iinc.win, $2)) return | hdel $iinc.win $2 | if ($hget($iinc.win, 0).item == 0) hfree $iinc.win

;order nicks list by who talked last
on *:text:*:#:if ($nick == $me) return | var %t = $nickstrip($nick) | if ($nick ison $chan) { dline $iinc.win $fline($iinc.win,$chan & $nick %t,1) | iline $iinc.win 1 $chan * $nick %t }
on *:action:*:#:if ($nick == $me) return | var %t = $nickstrip($nick) | if ($nick ison $chan) { dline $iinc.win $fline($iinc.win,$chan & $nick %t,1) | iline $iinc.win 1 $chan * $nick %t }

;editbox check and handling
on *:signal:edit_change:edit_change $1-
on *:signal:edit_cursor:{
  var %a = $remove($active, $chr(32))
  if ($iinc.m(%a)) iinc.c %a $true
}
on *:signal:edit_select:{
  var %a = $remove($active, $chr(32))
  if ($iinc.m(%a)) iinc.c %a $true
}

alias edit_change {
  var %a = $remove($active,$chr(32)), %e = $editbox($active), %t, %n = 0, %w, %v, %p, %l

  ;backspace-undo
  if (%iinc.bsundo != 0) && ($mouse.key !& 4) {
    if ($iinc.m(%a)) {
      if (!$iinc.c(%a)) {
        ;Holy shit. A buggy thing where my complaint is that mIRC is NOT condensing my spaces?!
        %t = $iinc.t(%a)

        if ($iinc.p(%a)) %p = $ifmatch
        else %p = $numtok(%t, 32)

        var %% = $1-

        tokenize 32 %e
        var %%e = $1-

        tokenize 32 $iinc.l(%a)
        var %%l = $1-

        tokenize 32 %%

        if (%%l == %%e) {
          %l = $len($gettok(%t, 1- $+ %p, 32)) + 1
          eb -ab $+ %l $+ e $+ %l %t
          return $edit_clear
        }
      }

      if ($numtok($left(%e, $editbox($active).selstart), 32) == $iif(%p, %p, 1)) && ($right($left($editbox($active), $editbox($active).selstart), 2) != $str($chr(32),2)) return
    }
    if ($right($editbox($active), 1) != $chr(32)) return $edit_clear
  }

  if ($prop == bschk) return

  if ($iinc.c(%a)) edit_clear
  if ($and(%iinc.on, 1) == 0) || ($right($editbox($active),1) != $chr(32)) || ($mid($editbox($active),-2,1) != $chr(32)) {
    edit_clear
    return
  }

  %t = $deltok(%e,-1,32)
  %w = $gettok(%e,-1,32) $+ *

  ;moved to actual $iinc alias
  ; match active window
  ; if ($iinc.t(%a) $+ * iswm %a) && ($iinc.t(%a)) { eb -ap $ifmatch | iinc.t %a | return }
  ; elseif ($gettok(%e,-1,32) $+ * iswm $active) && ($gettok(%e,-1,32)) { %t = $deltok(%e,-1,32) $active | iinc.t %a %e | eb -ap %t | return }

  ;complete nicks
  if ($window($1).type isin channel query) {
    if ($iinc.t(%a)) {
      %w = $gettok($ifmatch,-1,32) $+ *
      %t = $deltok($ifmatch,-1,32)
    }
    elseif (!$iinc.m(%a)) {
      iinc.t %a %e
      iinc.s %a $true
    }
    %n = $iinc.m(%a)

    var %noop = $regex(%w, /^([ $+ $prefix $+ ]*)(.*)/)
    var %pre = $regml(1), %w = $regml(2)

    if (%w == *) && (%pre != $null) return

    inc %n
    %v = $iinc(%a, %w, %n)
    var %ov = %v

    if ((%v != $active) || ($window($active).type != channel)) && ($numtok(%e, 32) <= 1) && ($iinc.suf != 0) && ($mouse.key !& 2) && (%pre == $null) && (%v != $null) %v = $iinc.suf(%v)

    if (%v) {
      eb -a $+ $iif(!$and($mouse.key,2),p) %t %pre $+ %v
      if (%t == $null) iinc.p %a 1
      iinc.l %a %t %pre $+ $left(%ov, -1)
      iinc.m %a %n
    }
    else {
      eb -a $+ $iif($iinc.t(%a),p $ifmatch)
      iinc.m %a
      iinc.t %a
    }
  }
}
on *:signal:edit_clear:$edit_clear($1-).bschk
alias edit_clear {
  if ($prop == bschk) && ($edit_change().bschk) return
  var %a = $remove($active,$chr(32))
  iinc.m %a
  iinc.t %a
  iinc.p %a
  iinc.s %a
  iinc.c %a
  iinc.l %a
}

; tabcomp event - lots of redundant code with edit_change; maybe i can consolidate?
on *:tabcomp:#:tabcomp $1-
on *:tabcomp:?:tabcomp $1-
alias tabcomp {
  if ($and(%iinc.on, 2) == 0) return
  if ($editbox($active).selstart == $editbox($active).selend) {
    var %e = $editbox($active), %p = $numtok($left(%e, $ifmatch), 32), %a = $remove($active,$chr(32)), %n = 0, %w = $gettok(%e,%p,32) $+ *, %v, %t, %l, %first = $false

    if ($iinc.c(%a)) edit_clear

    if ($iinc.p(%a)) %p = $ifmatch
    else iinc.p %a %p

    if ($iinc.t(%a)) %w = $gettok($ifmatch, %p, 32) $+ *
    elseif (!$iinc.m(%a)) {
      iinc.t %a %e
      if ($right($editbox($active), 1) == $chr(32)) iinc.s %a $true
      %first = $true
    }
    %n = $iinc.m(%a)

    var %noop = $regex(%w, /^([ $+ $prefix $+ ]*)(.*)/)
    var %pre = $regml(1), %w = $regml(2)

    inc %n

    if (%n == 0) return
    if (%w == *) && (%pre != $null) return

    if ($chr(37) $+ * !iswm $gettok(%e,%p,32)) || (!$var($v2)) %v = $iinc(%a, %w, %n)
    var %ov = %v, %spc = $false

    if ((%v != $active) || ($window($active).type != channel)) && ($numtok(%e, 32) <= 1) && ($iinc.suf != 0) && ($mouse.key !& 2) && (%pre == $null) && (%v != $null) {
      %v = $iinc.suf(%v)
      %spc = $true
    }

    if (%v) {
      if (%e == $null) {
        %t = %v
        %p = 1
      }
      else %t = $puttok(%e, %pre $+ %v, %p, 32)

      if ($iinc.s(%a)) %spc = $true


      %l = $calc($len($gettok(%t, 1- $+ %p, 32)) + 1 + $iif((%spc) && (%p == $numtok(%t, 32)), 1, 0))
      eb -a $+ $iif(%spc, p) $+ b $+ %l $+ e $+ %l %t

      if (%e == $null) iinc.l %a %pre $+ $left(%ov, -1)
      else iinc.l %a $puttok(%e, %pre $+ $left(%ov, -1), %p, 32)

      iinc.m %a %n
    }
    else {
      if (%first) {
        var %noop = $complete_code(%e, %p)

        ; FUCK YOU MIRC
        ; 2 hours spent bug hunting led me to add the below 'haltdef'
        ; TODO: Submit a bug report, after somehow managing to actually recreate the circumstances in a simpler way
        return
      }

      %t = $iinc.t(%a)
      %l = $calc($len($gettok(%t, 1- $+ %p, 32)) + 1 + $iif(($iinc.s(%a)) && (%p == $numtok(%t, 32)), 1, 0))
      eb -a $+ $iif($iinc.s(%a), p) $+ b $+ %l $+ e $+ %l %t
      edit_clear
    }
    halt
  }
}

on *:tabcomp:*:{
  if ($editbox($active).selstart == $editbox($active).selend) {
    var %e = $editbox($active), %p = $numtok($left(%e, $ifmatch), 32), %w, %a = $remove($active, $chr(32))

    if ($iinc.t(%a)) %w = $gettok($ifmatch, %p, 32) $+ *
    elseif (!$iinc.m(%a)) {
      iinc.t %a %e
      if ($right($editbox($active), 1) == $chr(32)) iinc.s %a $true
    }
    %n = $iinc.m(%a)

    if ($iinc.p(%a)) %p = $ifmatch
    else iinc.p %a %p

    return $complete_code(%e, %p)
  }
}

alias complete_code {
  if (!%iinc.code) return
  var %e = $1, %p = $2, %a = $remove($active, $chr(32))
  var %t = $gettok(%e, 1- $+ %p, 32), %re, %pre

  ; = /(?:^|\x20)(\$([^\(\x20]*)\((.*?)\))$/
  ; Thanks jaytea! [(?N) syntax]

  ; support matched parenthesis in parameters ($calc)
  var %re = /(.*(?:^|\x20|\x2C|\())(\x23|(?:\x23?\$[^() ]*(?:(\(([^()]|(?3)|\((?2)\))*\)(?:\.[^ ]+)?)?|(\x25[^ ]+))))$/
  ;var %re = /(.*)(?:^|\x20)(\x23?\$[^()]*(?:(\((?:[^()]|(?2))*\)(?:\.[^ ]+)?)?))$/

  noop $regex(cc, %t, %re)
  %t = $regml(cc, 2)

  ;Temporarily removed due to a mIRC bug affecting other code
  ; .. temporarily reinstated with modification due to a DIFFERENT mIRC bug.
  if ($numtok(%t, 32) == 1) && ($len(%t) <= 90) && ($!input* iswm %t) return

  %v = $eval_code(%t)

  if (%v == $null) {
    beep 1
    haltdef
    return
  }

  var %op = %p

  %p = $calc(%p - $numtok(%t, 32) + 1) $+ - $+ %p
  ;%t = $instok($deltok(%e, %p, 32), %v, %p, 32)
  %l = $calc($iif($regml(cc, 1) != $null, $len($regml(cc, 1)), 0) + $len(%v) + 1 + $iif(($iinc.s(%a)) && (%op == $numtok(%e, 32)), 1, 0))

  var %suf = $gettok(%e, $calc(%op + 1) $+ -, 32)
  %t = $+($regml(cc, 1), %v) %suf

  eb -a $+ $iif($iinc.s(%a), p) $+ b $+ %l $+ e $+ %l %t

  iinc.p %a $gettok(%p, 2, 45)
  iinc.m %a -1

  %t = $+($regml(cc, 1), $left(%v, -1)) %suf
  ;if ($left(%v, -1) != $null) %t = $instok(%t, $ifmatch, %p, 32)

  iinc.l %a %t
  haltdef
}

; To prevent the completion of variables from completing local vars in the above alias.
alias -l eval_code return $eval($1, 2)

;fill nick windows if script is loaded while online
;this command _should_ fix dline errors if you come across them
;/scid -at1 iinc_names
alias iinc_names {
  var %i, %j, %t
  if (!$window($iinc.win)) window -lhn $iinc.win
  clear $iinc.win
  %i = $chan(0)

  while (%i) {
    %j = $nick($chan(%i),0)
    while (%j) {
      %t = $nick($chan(%i),%j)
      aline $iinc.win $chan(%i) * %t $nickstrip(%t)
      dec %j
    }
    dec %i 
  }
}

;find us a match
alias iinc {
  if (!$isid) { iinc_config | return }
  var %w = $2, %n = $3, %t, %u

  ;moved to allow the relocation of styling
  ; for @nick-que @nick-remove etc.
  ; if ($len(%w) > 2) && (@* iswm %w) { %t = $left(%w,1) | %w = $mid(%w,2) }

  if (%n > $fline($iinc.win,$1 * %w,0)) {
    ;active window match
    if (%w iswm $active) && (%n == 1) return $active
    return
  }

  ;nick match
  %u = $gettok($line($iinc.win,$fline($iinc.win,$1 * %w,%n)),3,32)

  ;moved to enable other changes
  ; if ($prop == s) && (%t == $null) return $iinc.suf(%u)
  ; else
  return %t $+ %u
}

;patch files with old versions of oc_chk
alias iinc_patch {
  echo -a Patching old versions of oc_chk...

  bread $qt($script) 0 $lof($script) &patch

  var %s = $bfind(&patch, 1, 13 10 35 105 105 110 99 95 111 99 32 111 110 13 10)
  inc %s 15

  var %e = $bfind(&patch, %s, 13 10 35 105 105 110 99 95 111 99 32 101 110 100 13 10)

  bcopy -c &patch 1 &patch %s $calc(%e - %s)

  var %i = $script(0), %j, %err, %t = ;1.3
  while (%i) { 

    if ($read($script(%i), nw, alias oc_chk *)) {
      %err = $false

      %j = $readn + 1
      if ($read($script(%i), n, %j) != %t) {
        bunset &in | bunset &out

        bread $qt($script(%i)) 0 $lof($script(%i)) &in

        var %s = $bfind(&in, 1, 13 10 97 108 105 97 115 32 111 99 95 99 104 107 32 123 13 10) + 1
        if (%s == 1) %err = $true
        bcopy &out 1 &in 1 %s

        bcopy &out $calc($bvar(&out, 0) + 1) &patch 1 -1

        var %e = $bfind(&in, %s, 13 10 125 13 10) + 5
        if (%e == 5) %err = $true

        if (alias oc_reset == $bvar(&in, %e, 14).text) %e = $bfind(&in, %e, 13 10 125 13 10) + 5

        dec %e 2

        bcopy &out $calc($bvar(&out, 0) + 1) &in %e -1

        if (%err != $true) {
          echo -a * /iinc_patch: Backing up $script(%i) to $script(%i) $+ .bak
          .copy -o $qt($script(%i)) $qt($puttok($script(%i), $nopath($script(%i)) $+ .bak, -1, 92))
          echo -a * /iinc_patch: removing $script(%i)
          .remove $qt($script(%i))
          echo -a * /iinc_patch: writing $script(%i)
          .bwrite $qt($script(%i)) 0 -1 &out
          echo -a * /iinc_patch: reloading $script(%i)
          .reload -rs $qt($script(%i))
        }
        else {
          echo -a * iinc_patch: Error in $script(%i) -- skipping
        }
      }
    }
    dec %i
  }
}



;internal use
alias -l iinc.win return @iinc. $+ $cid
;i should have logged what all these are for, now i can't remember!
alias -l iinc.s if (!$hget(iinc)) hmake iinc 10 | if ($isid) return $hget(iinc,s_ $+ $1) | if ($0 == 1) hdel iinc s_ $+ $1 | elseif ($0 > 1) hadd iinc s_ $+ $1 $2-
alias -l iinc.t if (!$hget(iinc)) hmake iinc 10 | if ($isid) return $hget(iinc,t_ $+ $1) | if ($0 == 1) hdel iinc t_ $+ $1 | elseif ($0 > 1) hadd iinc t_ $+ $1 $2-
alias -l iinc.p if (!$hget(iinc)) hmake iinc 10 | if ($isid) return $hget(iinc,p_ $+ $1) | if ($0 == 1) hdel iinc p_ $+ $1 | elseif ($0 > 1) hadd iinc p_ $+ $1 $2-
alias -l iinc.m if (!$hget(iinc)) hmake iinc 10 | if ($isid) return $hget(iinc,m_ $+ $1) | if ($0 == 1) hdel iinc m_ $+ $1 | elseif ($0 > 1) hadd iinc m_ $+ $1 $2-
;iinc.c returns $true if the cursor has moved after completing something
alias -l iinc.c if (!$hget(iinc)) hmake iinc 10 | if ($isid) return $hget(iinc,c_ $+ $1) | if ($0 == 1) hdel iinc c_ $+ $1 | elseif ($0 > 1) hadd iinc c_ $+ $1 $2-
;iinc.l returns the result of the last completion - used for backspace-undo
alias -l iinc.l if (!$hget(iinc)) hmake iinc 10 | if ($isid) return $hget(iinc,l_ $+ $1) | if ($0 == 1) hdel iinc l_ $+ $1 | elseif ($0 > 1) hadd iinc l_ $+ $1 $2-
alias -l iinc.suf if ($1 == $null) return $iif(%iinc.suf == $null,1,%iinc.suf) | else return $replace($iif(%iinc.style == $null,&n:,%iinc.style),&n,$1)
alias -l nickstrip return $iif($remove($1,[,],-,_,`,^,\,$chr(123),$chr(124),$chr(125)) != $null,$ifmatch,$1)
alias -l dline if ($2 == $null) iinc_names | else dline $1-
alias -l eb editbox $1- | oc_reset

;config
menu menubar {
  iinc config:iinc_config
}

alias iinc_config dialog -m iinc iinc

dialog iinc {
  title "iinc config"
  size -1 -1 121 128
  option dbu
  check "Enable iinc with &space", 20, 3 3 67 10
  check "Enable iinc with &tab", 21, 3 14 67 10
  check "Enable enhanced &code evaluation", 23, 3 25 107 10
  check "Enable &backspace-undo", 22, 3 36 67 10

  check "&Apply style to completed nickname:", 2, 3 47 99 10
  edit "", 3, 11 59 107 10
  text "Use &&n for the completed nickname. Example: [&&n]:", 4, 13 72 90 15
  text "Note: Styles are only applied to the completed nickname if it is the first word in the editbox.", 5, 4 91 114 16
  button "OK", 6, 41 113 37 12, default ok
  button "Cancel", 7, 81 113 37 12, cancel
  link "Readme", 8, 4 116 22 8
}
on *:dialog:iinc:init:*:{
  if (%iinc.on == $null) || (%iinc.on & 1) did -c iinc 20
  if (%iinc.on & 2) did -c iinc 21
  if (%iinc.bsundo == $null) || (%iinc.bsundo == 1) did -c iinc 22
  if (%iinc.suf == $null) || (%iinc.suf == 1) did -c iinc 2
  if (%iinc.style == $null) %iinc.style = &n:
  if (%iinc.code) did -c iinc 23
  did -a iinc 3 %iinc.style
  if ($version < 6.2) did -b iinc 21,23 
}
on *:dialog:iinc:sclick:6:{
  %iinc.on = $calc($did(iinc,20).state + 2 * $did(iinc,21).state)
  %iinc.suf = $did(iinc,2).state
  %iinc.style = $did(iinc,3).text
  %iinc.bsundo = $did(iinc, 22).state
  %iinc.code = $did(iinc, 23).state
}
on *:dialog:iinc:sclick:8:{
  .run " $+ $scriptdirreadme.txt $+ "
}


;edit_change/edit_clear signals
;sends out a signal when active window's editbox is changed/cleared

on *:start:if ($timer(oc) == $null) oc_chk
on *:input:*:$edit_clear().nobs | if ($timer(oc) == $null) oc_chk

#iinc_oc on
alias oc_chk {
  ;1.3
  if (!$timer(oc)) .timeroc -oim 0 10 if ($isalias(oc_chk)) oc_chk $chr(124) else .timeroc off
  var %e = $editbox($active), %a = $remove($active,$chr(32)), %w = $window($active).wid, %t, %nocursor = $false
  tokenize 32 $hget(oc, %w)
  if ($hash($editbox($active),32) != $1) {
    if ($hash($editbox($active),32) == $null) {
      hdel oc $window($active).wid
      .signal -n edit_clear %a
      return
    }
    else {
      %t = $hash($editbox($active),32)
      .signal -n edit_change %a
      %nocursor = $true
    }
  }
  tokenize 32 $hget(oc, %w)
  var %ss = $iif($editbox($active).selstart != $null, $ifmatch, 1), %se = $iif($editbox($active).selend != $null, $ifmatch, 1)
  var %tss = $iif($2 != $null, $ifmatch, 1), %tse = $iif($3 != $null, $ifmatch, 1)
  if (%t == $null) %t = $1
  hadd -m oc %w %t %ss %se
  if (%nocursor) return
  if (%ss != %tss) || (%se != %tse) {
    if (%ss == %se) .signal -n edit_cursor %a %ss %se
    else .signal -n edit_select %a %ss %se
  }
}
alias oc_reset {
  var %ss = $editbox($active).selstart, %se = $editbox($active).selend, %w = $window($active).wid
  hadd -m oc %w $hash($editbox($active),32) %ss %se
}
#iinc_oc end

alias -l qt return $+(",$remove($1,"),")
